/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.edge;


import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class MeshSurfaceUtils {
	
	public static List<PolygonPolygonIntersection> selfIntersects(MeshSurface ms, double epsilon, double angleEpsilon) {
		Objects.requireNonNull(ms);
		List<CDPolygonNs> polygons = ms.getPolygons();
		List<PolygonPolygonIntersection> intersections = new ArrayList<>();
		for (int i = 0; i < polygons.size() - 1; i++) {
			EdgePolygon p1 = polygons.get(i);
			for (int j = i + 1; j < polygons.size(); j++) {
				EdgePolygon p2 = polygons.get(j);
				List<PolygonPolygonIntersection> result = IntersectPlanarPolygons.intersectPolygons(p1, p2, epsilon, angleEpsilon);
				intersections.addAll(result);
			}
		}
		return intersections;
	}
	
	private MeshSurfaceUtils() {
	}

}
